// Code generated by SQLBoiler 3.5.0 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"bytes"
	"context"
	"reflect"
	"testing"

	"github.com/volatiletech/sqlboiler/boil"
	"github.com/volatiletech/sqlboiler/queries"
	"github.com/volatiletech/sqlboiler/randomize"
	"github.com/volatiletech/sqlboiler/strmangle"
)

var (
	// Relationships sometimes use the reflection helper queries.Equal/queries.Assign
	// so force a package dependency in case they don't.
	_ = queries.Equal
)

func testProductRecipes(t *testing.T) {
	t.Parallel()

	query := ProductRecipes()

	if query.Query == nil {
		t.Error("expected a query, got nothing")
	}
}

func testProductRecipesDelete(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProductRecipe{}
	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := o.Delete(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := ProductRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testProductRecipesQueryDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProductRecipe{}
	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := ProductRecipes().DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := ProductRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testProductRecipesSliceDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProductRecipe{}
	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := ProductRecipeSlice{o}

	if rowsAff, err := slice.DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := ProductRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testProductRecipesExists(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProductRecipe{}
	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	e, err := ProductRecipeExists(ctx, tx, o.RecipeID, o.ProductID)
	if err != nil {
		t.Errorf("Unable to check if ProductRecipe exists: %s", err)
	}
	if !e {
		t.Errorf("Expected ProductRecipeExists to return true, but got false.")
	}
}

func testProductRecipesFind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProductRecipe{}
	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	productRecipeFound, err := FindProductRecipe(ctx, tx, o.RecipeID, o.ProductID)
	if err != nil {
		t.Error(err)
	}

	if productRecipeFound == nil {
		t.Error("want a record, got nil")
	}
}

func testProductRecipesBind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProductRecipe{}
	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = ProductRecipes().Bind(ctx, tx, o); err != nil {
		t.Error(err)
	}
}

func testProductRecipesOne(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProductRecipe{}
	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if x, err := ProductRecipes().One(ctx, tx); err != nil {
		t.Error(err)
	} else if x == nil {
		t.Error("expected to get a non nil record")
	}
}

func testProductRecipesAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	productRecipeOne := &ProductRecipe{}
	productRecipeTwo := &ProductRecipe{}
	if err = randomize.Struct(seed, productRecipeOne, productRecipeDBTypes, false, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}
	if err = randomize.Struct(seed, productRecipeTwo, productRecipeDBTypes, false, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = productRecipeOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = productRecipeTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := ProductRecipes().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 2 {
		t.Error("want 2 records, got:", len(slice))
	}
}

func testProductRecipesCount(t *testing.T) {
	t.Parallel()

	var err error
	seed := randomize.NewSeed()
	productRecipeOne := &ProductRecipe{}
	productRecipeTwo := &ProductRecipe{}
	if err = randomize.Struct(seed, productRecipeOne, productRecipeDBTypes, false, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}
	if err = randomize.Struct(seed, productRecipeTwo, productRecipeDBTypes, false, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = productRecipeOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = productRecipeTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := ProductRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 2 {
		t.Error("want 2 records, got:", count)
	}
}

func productRecipeBeforeInsertHook(ctx context.Context, e boil.ContextExecutor, o *ProductRecipe) error {
	*o = ProductRecipe{}
	return nil
}

func productRecipeAfterInsertHook(ctx context.Context, e boil.ContextExecutor, o *ProductRecipe) error {
	*o = ProductRecipe{}
	return nil
}

func productRecipeAfterSelectHook(ctx context.Context, e boil.ContextExecutor, o *ProductRecipe) error {
	*o = ProductRecipe{}
	return nil
}

func productRecipeBeforeUpdateHook(ctx context.Context, e boil.ContextExecutor, o *ProductRecipe) error {
	*o = ProductRecipe{}
	return nil
}

func productRecipeAfterUpdateHook(ctx context.Context, e boil.ContextExecutor, o *ProductRecipe) error {
	*o = ProductRecipe{}
	return nil
}

func productRecipeBeforeDeleteHook(ctx context.Context, e boil.ContextExecutor, o *ProductRecipe) error {
	*o = ProductRecipe{}
	return nil
}

func productRecipeAfterDeleteHook(ctx context.Context, e boil.ContextExecutor, o *ProductRecipe) error {
	*o = ProductRecipe{}
	return nil
}

func productRecipeBeforeUpsertHook(ctx context.Context, e boil.ContextExecutor, o *ProductRecipe) error {
	*o = ProductRecipe{}
	return nil
}

func productRecipeAfterUpsertHook(ctx context.Context, e boil.ContextExecutor, o *ProductRecipe) error {
	*o = ProductRecipe{}
	return nil
}

func testProductRecipesHooks(t *testing.T) {
	t.Parallel()

	var err error

	ctx := context.Background()
	empty := &ProductRecipe{}
	o := &ProductRecipe{}

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, o, productRecipeDBTypes, false); err != nil {
		t.Errorf("Unable to randomize ProductRecipe object: %s", err)
	}

	AddProductRecipeHook(boil.BeforeInsertHook, productRecipeBeforeInsertHook)
	if err = o.doBeforeInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeInsertHook function to empty object, but got: %#v", o)
	}
	productRecipeBeforeInsertHooks = []ProductRecipeHook{}

	AddProductRecipeHook(boil.AfterInsertHook, productRecipeAfterInsertHook)
	if err = o.doAfterInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterInsertHook function to empty object, but got: %#v", o)
	}
	productRecipeAfterInsertHooks = []ProductRecipeHook{}

	AddProductRecipeHook(boil.AfterSelectHook, productRecipeAfterSelectHook)
	if err = o.doAfterSelectHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterSelectHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterSelectHook function to empty object, but got: %#v", o)
	}
	productRecipeAfterSelectHooks = []ProductRecipeHook{}

	AddProductRecipeHook(boil.BeforeUpdateHook, productRecipeBeforeUpdateHook)
	if err = o.doBeforeUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpdateHook function to empty object, but got: %#v", o)
	}
	productRecipeBeforeUpdateHooks = []ProductRecipeHook{}

	AddProductRecipeHook(boil.AfterUpdateHook, productRecipeAfterUpdateHook)
	if err = o.doAfterUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpdateHook function to empty object, but got: %#v", o)
	}
	productRecipeAfterUpdateHooks = []ProductRecipeHook{}

	AddProductRecipeHook(boil.BeforeDeleteHook, productRecipeBeforeDeleteHook)
	if err = o.doBeforeDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeDeleteHook function to empty object, but got: %#v", o)
	}
	productRecipeBeforeDeleteHooks = []ProductRecipeHook{}

	AddProductRecipeHook(boil.AfterDeleteHook, productRecipeAfterDeleteHook)
	if err = o.doAfterDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterDeleteHook function to empty object, but got: %#v", o)
	}
	productRecipeAfterDeleteHooks = []ProductRecipeHook{}

	AddProductRecipeHook(boil.BeforeUpsertHook, productRecipeBeforeUpsertHook)
	if err = o.doBeforeUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpsertHook function to empty object, but got: %#v", o)
	}
	productRecipeBeforeUpsertHooks = []ProductRecipeHook{}

	AddProductRecipeHook(boil.AfterUpsertHook, productRecipeAfterUpsertHook)
	if err = o.doAfterUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpsertHook function to empty object, but got: %#v", o)
	}
	productRecipeAfterUpsertHooks = []ProductRecipeHook{}
}

func testProductRecipesInsert(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProductRecipe{}
	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := ProductRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testProductRecipesInsertWhitelist(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProductRecipe{}
	if err = randomize.Struct(seed, o, productRecipeDBTypes, true); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Whitelist(productRecipeColumnsWithoutDefault...)); err != nil {
		t.Error(err)
	}

	count, err := ProductRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testProductRecipeToOneRecipeUsingRecipe(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local ProductRecipe
	var foreign Recipe

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, productRecipeDBTypes, false, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, recipeDBTypes, false, recipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Recipe struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	local.RecipeID = foreign.ID
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.Recipe().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if check.ID != foreign.ID {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := ProductRecipeSlice{&local}
	if err = local.L.LoadRecipe(ctx, tx, false, (*[]*ProductRecipe)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Recipe == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.Recipe = nil
	if err = local.L.LoadRecipe(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Recipe == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testProductRecipeToOneProductUsingProduct(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local ProductRecipe
	var foreign Product

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, productRecipeDBTypes, false, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, productDBTypes, false, productColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Product struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	local.ProductID = foreign.ID
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.Product().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if check.ID != foreign.ID {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := ProductRecipeSlice{&local}
	if err = local.L.LoadProduct(ctx, tx, false, (*[]*ProductRecipe)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Product == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.Product = nil
	if err = local.L.LoadProduct(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Product == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testProductRecipeToOneSetOpRecipeUsingRecipe(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a ProductRecipe
	var b, c Recipe

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, productRecipeDBTypes, false, strmangle.SetComplement(productRecipePrimaryKeyColumns, productRecipeColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, recipeDBTypes, false, strmangle.SetComplement(recipePrimaryKeyColumns, recipeColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, recipeDBTypes, false, strmangle.SetComplement(recipePrimaryKeyColumns, recipeColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*Recipe{&b, &c} {
		err = a.SetRecipe(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.Recipe != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.ProductRecipes[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if a.RecipeID != x.ID {
			t.Error("foreign key was wrong value", a.RecipeID)
		}

		if exists, err := ProductRecipeExists(ctx, tx, a.RecipeID, a.ProductID); err != nil {
			t.Fatal(err)
		} else if !exists {
			t.Error("want 'a' to exist")
		}

	}
}
func testProductRecipeToOneSetOpProductUsingProduct(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a ProductRecipe
	var b, c Product

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, productRecipeDBTypes, false, strmangle.SetComplement(productRecipePrimaryKeyColumns, productRecipeColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, productDBTypes, false, strmangle.SetComplement(productPrimaryKeyColumns, productColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, productDBTypes, false, strmangle.SetComplement(productPrimaryKeyColumns, productColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*Product{&b, &c} {
		err = a.SetProduct(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.Product != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.ProductRecipes[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if a.ProductID != x.ID {
			t.Error("foreign key was wrong value", a.ProductID)
		}

		if exists, err := ProductRecipeExists(ctx, tx, a.RecipeID, a.ProductID); err != nil {
			t.Fatal(err)
		} else if !exists {
			t.Error("want 'a' to exist")
		}

	}
}

func testProductRecipesReload(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProductRecipe{}
	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = o.Reload(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testProductRecipesReloadAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProductRecipe{}
	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := ProductRecipeSlice{o}

	if err = slice.ReloadAll(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testProductRecipesSelect(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &ProductRecipe{}
	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := ProductRecipes().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 1 {
		t.Error("want one record, got:", len(slice))
	}
}

var (
	productRecipeDBTypes = map[string]string{`RecipeID`: `int`, `ProductID`: `int`, `Count`: `float`}
	_                    = bytes.MinRead
)

func testProductRecipesUpdate(t *testing.T) {
	t.Parallel()

	if 0 == len(productRecipePrimaryKeyColumns) {
		t.Skip("Skipping table with no primary key columns")
	}
	if len(productRecipeAllColumns) == len(productRecipePrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &ProductRecipe{}
	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := ProductRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipePrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	if rowsAff, err := o.Update(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only affect one row but affected", rowsAff)
	}
}

func testProductRecipesSliceUpdateAll(t *testing.T) {
	t.Parallel()

	if len(productRecipeAllColumns) == len(productRecipePrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &ProductRecipe{}
	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipeColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := ProductRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, productRecipeDBTypes, true, productRecipePrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	// Remove Primary keys and unique columns from what we plan to update
	var fields []string
	if strmangle.StringSliceMatch(productRecipeAllColumns, productRecipePrimaryKeyColumns) {
		fields = productRecipeAllColumns
	} else {
		fields = strmangle.SetComplement(
			productRecipeAllColumns,
			productRecipePrimaryKeyColumns,
		)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	typ := reflect.TypeOf(o).Elem()
	n := typ.NumField()

	updateMap := M{}
	for _, col := range fields {
		for i := 0; i < n; i++ {
			f := typ.Field(i)
			if f.Tag.Get("boil") == col {
				updateMap[col] = value.Field(i).Interface()
			}
		}
	}

	slice := ProductRecipeSlice{o}
	if rowsAff, err := slice.UpdateAll(ctx, tx, updateMap); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("wanted one record updated but got", rowsAff)
	}
}

func testProductRecipesUpsert(t *testing.T) {
	t.Parallel()

	if len(productRecipeAllColumns) == len(productRecipePrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}
	if len(mySQLProductRecipeUniqueColumns) == 0 {
		t.Skip("Skipping table with no unique columns to conflict on")
	}

	seed := randomize.NewSeed()
	var err error
	// Attempt the INSERT side of an UPSERT
	o := ProductRecipe{}
	if err = randomize.Struct(seed, &o, productRecipeDBTypes, false); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Upsert(ctx, tx, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert ProductRecipe: %s", err)
	}

	count, err := ProductRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}

	// Attempt the UPDATE side of an UPSERT
	if err = randomize.Struct(seed, &o, productRecipeDBTypes, false, productRecipePrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize ProductRecipe struct: %s", err)
	}

	if err = o.Upsert(ctx, tx, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert ProductRecipe: %s", err)
	}

	count, err = ProductRecipes().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}
}
